

Highcharts.DefaultTheme = {
	colors: ['#2f7ed8', '#0d233a', '#8bbc21', '#910000', '#1aadce', '#492970',
		'#f28f43', '#77a1e5', '#c42525', '#a6c96a'],
	chart: {
		backgroundColor: '#FFFFFF',
		className: '',
		borderColor: '#4572A7',
		borderWidth: 0,
		borderRadius: 5,
		plotShadow: false,
		plotBackgroundImage: '',
		plotBackgroundColor: '',
		plotBorderColor: '#C0C0C0',
		plotBorderWidth: 0,
		style: {
			fontFamily: '"Lucida Grande", "Lucida Sans Unicode", Verdana, Arial, Helvetica, sans-serif', 
			fontSize: '12px'
		}
	},
	title: {
		style: {
			color: '#274b6d',
			font: '',
			fontSize: '16px'
		}
	},
	subtitle: {
		style: {
			color: '#4d759e',
			font: ''
		}
	},
	xAxis: {
		gridLineColor: '#C0C0C0',
		gridLineWidth: 0,
		lineColor: '#C0D0E0',
		tickColor: '#C0D0E0',
		labels: {
			style: {
				color: '#666',
				font: '',
				fontWeight: ''
			}
		},
		title: {
			style: {
				color: '#4d759e',
				font: '',
				fontWeight: 'bold',
				fontFamily: '"Lucida Grande", "Lucida Sans Unicode", Verdana, Arial, Helvetica, sans-serif', 
				fontSize: '12px'
			}
		}
	},
	yAxis: {
		alternateGridColor: '',
		minorTickInterval: '',
		minorGridLineColor: '#E0E0E0',
		gridLineColor: '#C0C0C0',
		lineColor: '#C0D0E0',
		tickColor: '#C0D0E0',
		tickWidth: 1,
		lineWidth: 1,
		labels: {
			style: {
				color: '#666',
				font: '',
				fontWeight: ''
			}
		},
		title: {
			style: {
				color: '#4d759e',
				font: '',
				fontWeight: 'bold',
				fontFamily: '"Lucida Grande", "Lucida Sans Unicode", Verdana, Arial, Helvetica, sans-serif', 
				fontSize: '12px'
			}
		}
	},
	tooltip: {
		backgroundColor: 'rgba(255, 255, 255, .85)',
		borderWidth: 1,
		style: {
			color: '#333333'
		}
	},
	toolbar: {
		itemStyle: {
			color: '#4572A7'
		}
	},
	plotOptions: {
		series: {
			shadow: false
		},
		line: {
			dataLabels: {
				color: '#666'
			},
			marker: {
				lineColor: '#FFFFFF'
			}
		},
		spline: {
			marker: {
				lineColor: '#FFFFFF'
			}
		},
		scatter: {
			marker: {
				lineColor: '#FFFFFF'
			}
		},
		candlestick: {
			lineColor: 'white'
		}
	},
	legend: {
		itemStyle: {
			font: '',
			color: '#274b6d'
		},
		itemHoverStyle: {
			color: '#000'
		},
		itemHiddenStyle: {
			color: '#CCC'
		}
	},
	credits: {
		style: {
			color: '#909090'
		}
	},
	labels: {
		style: {
			color: '#3E576F'
		}
	},
	navigation: {
		buttonOptions: {
			symbolFill: '#E0E0E0',
			symbolStroke: '#666',
			hoverSymbolStroke: '',
			theme: {
				fill: 'white', 
				stroke: 'none'
			}
		}
	},

	
	rangeSelector: {
		buttonTheme: {
			fill: {
				linearGradient: { x1: 0, y1: 0, x2: 0, y2: 1 },
				stops: [
					[0.4, '#888'],
					[0.6, '#555']
				]
			},
			stroke: '#68A',
			style: {
				color: '#CCC',
				fontWeight: 'bold'
			},
			states: {
				hover: {
					fill: {
						linearGradient: { x1: 0, y1: 0, x2: 0, y2: 1 },
						stops: [
							[0.4, '#BBB'],
							[0.6, '#888']
						]
					},
					stroke: '#000000',
					style: {
						color: 'white'
					}
				},
				select: {
					fill: {
						linearGradient: { x1: 0, y1: 0, x2: 0, y2: 1 },
						stops: [
							[0.1, '#000'],
							[0.3, '#333']
						]
					},
					stroke: '#000000',
					style: {
						color: 'yellow'
					}
				}
			}
		},
		inputStyle: {
			backgroundColor: '#333',
			color: 'silver'
		},
		labelStyle: {
			color: 'silver'
		}
	},
	navigator: {
		handles: {
			backgroundColor: '#FFF',
			borderColor: '#666'
		},
		outlineColor: '#444',
		maskFill: 'rgba(255, 255, 255, 0.75)',
		series: {
			color: '#4572A7',
			lineColor: '#4572A7'
		}
	},

	scrollbar: {
		barBackgroundColor: {
				linearGradient: { x1: 0, y1: 0, x2: 0, y2: 1 },
				stops: [
					[0, '#FFF'],
					[1, '#CCC']
				]
			},
		barBorderColor: '#666',
		buttonArrowColor: '#666',
		buttonBackgroundColor: {
				linearGradient: { x1: 0, y1: 0, x2: 0, y2: 1 },
				stops: [
					[0, '#FFF'],
					[1, '#CCC']
				]
			},
		buttonBorderColor: '#666',
		rifleColor: '#666',
		trackBackgroundColor: {
			linearGradient: { x1: 0, y1: 0, x2: 0, y2: 1 },
			stops: [
				[0, '#EEE'],
				[1, '#FFF']
			]
		},
		trackBorderColor: '#CCC'
	},

	
	legendBackgroundColor: '#FFFFFF',
	legendBackgroundColorSolid: '#FFFFFF',
	dataLabelsColor: '#666',
	textColor: '#4572A7',
	maskColor: 'rgba(255,255,255,0.3)'
};